//+------------------------------------------------------------------+
//|                                             kama with filter.mq4 |
//|                                                                  |
//| Adaptive moving average (AMA)                                    |
//| Perry Kaufman variation                                          |
//| filter type author unknown                                       |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern int    KamaPrice        = PRICE_CLOSE;
extern int    KamaPeriod       =  14;
extern int    FastEndPeriod    =   2;
extern int    SlowEndPeriod    =  30;
extern double Power            = 2.0;
extern int    Filter           =  50;
extern int    FilterPeriod     =   4;
extern double FilterDifference =  10;

//
//
//
//
//

double fmaBuffer[];
double amaBuffer[];
double prcBuffer[];
double difBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,fmaBuffer);
      SetIndexBuffer(1,amaBuffer);
      SetIndexBuffer(2,prcBuffer);
      SetIndexBuffer(3,difBuffer);
   IndicatorShortName("Kama ( "+KamaPeriod+")");         
   return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   double slowend=2.0/(SlowEndPeriod+1);
   double fastend=2.0/(FastEndPeriod+1);
   int    counted_bars=IndicatorCounted();
   int    limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //

   for(i = limit; i >= 0; i--)
   {
      prcBuffer[i] = iMA(NULL,0,1,0,MODE_SMA,KamaPrice,i);
         if (i>=(Bars-KamaPeriod))
         {
            amaBuffer[i] = prcBuffer[i]; continue;
         }
         
      //
      //
      //
      //
      //
         
         double noise    = 0;
         double effratio = 1;
         double signal   = MathAbs(prcBuffer[i]-prcBuffer[i+KamaPeriod]);
            difBuffer[i] = MathAbs(prcBuffer[i]-prcBuffer[i+1]);
            for (int k=0;k<KamaPeriod; k++) noise += difBuffer[i+k];
            
            if (noise != 0) effratio = signal/noise;
            double smooth = MathPow(effratio*(fastend-slowend)+slowend,Power);
         
            //
            //
            //
            //
            //
         
         amaBuffer[i] = amaBuffer[i+1]+smooth*(prcBuffer[i]-amaBuffer[i+1]);
         fmaBuffer[i] = amaBuffer[i];               
         if (Filter<=0) continue;

      //
      //
      //    filter ???
      //
      //
    
      double sAmaDiff    = 0; for(k=0; k<SlowEndPeriod; k++) sAmaDiff += MathAbs(amaBuffer[i+k]-amaBuffer[i+k+1]);
      double cAmaDiff    = amaBuffer[i]-amaBuffer[i+1];
      double aAmaDiff    = MathAbs(cAmaDiff);
      double filterValue = NormalizeDouble(Filter*sAmaDiff/(100.0*SlowEndPeriod),4);
    
         if (cAmaDiff > 0) 
         if (cAmaDiff < filterValue && High[i]<=(High[iHighest(NULL,0,MODE_HIGH,FilterPeriod,i)]+FilterDifference*Point))
               fmaBuffer[i] = fmaBuffer[i+1];
         if (cAmaDiff < 0) 
         if (aAmaDiff < filterValue && Low[i]>=(Low[iLowest(NULL,0,MODE_LOW,FilterPeriod,i)]-FilterDifference*Point))
               fmaBuffer[i] = fmaBuffer[i+1];
   }

   //
   //
   //
   //
   //

   return(0);      
}
/*
	inputs:	period(numericsimple);
	vars:		efratio(0), smooth(1), fastend(.666), slowend(.0645), AMA(0), diff(0),
			signal(0), noise(0);

{ calculate efficiency ratio }
	if currentbar = 1 then
			AMA = close
		else begin
			efratio = 1;
			diff = absvalue(close - close[1]);
			signal = absvalue(close - close[period]);
			noise = summation(diff,period);
			if noise <> 0 then efratio = signal / noise;
			smooth = power(efratio*(fastend - slowend) + slowend,2);
			AMA = AMA[1] + smooth*(close - AMA[1]);
		end;
	TSMKAMA = AMA;   
*/	